package com.neurotech.filters;

public class FilterList {

    static {
        System.loadLibrary("android-filters");
    }

    private long mFilterListPtr;
    private boolean mIsFinalized;

    public FilterList()
    {
        mFilterListPtr = createFilterList();
    }

    public void addFilter(Filter filter)
    {
        addFilterToList(mFilterListPtr, filter.getNativePtr());
    }

    public double filter(double x)
    {
        return filter(mFilterListPtr, x);
    }

    public double[] filterArray(double[] xs)
    {
        return filterArray(mFilterListPtr, xs);
    }

    public void clearFilters()
    {
        clearFilters(mFilterListPtr);
    }

    public void reset()
    {
        reset(mFilterListPtr);
    }
    public void deleteFilter(Filter filter)
    {
        deleteFilter(mFilterListPtr, filter.getNativePtr());
    }

    @Override
    protected void finalize() throws Throwable
    {
        super.finalize();
        if(!mIsFinalized){
            mIsFinalized = true;
            deleteFilterList(mFilterListPtr);
            mFilterListPtr = 0;
        }
    }

    private static native void clearFilters(long filterListPtr);
    private static native void deleteFilterList(long filterListPtr);
    private static native long createFilterList();
    private static native void addFilterToList(long filterListPtr, long filterPtr);
    private static native double filter(long filterListPtr, double x);
    private static native double[] filterArray(long filterListPtr, double[] xs);
    private static native void reset(long filterListPtr);
    private static native void deleteFilter(long filterListPtr,long filterPtr);
}
